<?php
/**
 * Clase Base FN para BaseCrCreditoCronoComentarioFN
 *
 * @package    
 * @subpackage BaseCrCreditoCronoComentarioFN
 * @author     Willy
 * @version    SVN:: BaseCrCreditoCronoComentarioFN.class.php,v 1.1 2013-04-19 11:08:15 william.taype Exp $
 */
class BaseCrCreditoCronoComentarioFN extends CrCreditoCronoComentarioBN
{
  private static $fieldNames = array (
    'Idcreditocronocomentario'=>'idcreditocronocomentario', 'Idcreditocrono'=>'idcreditocrono', 'Fechatrx'=>'fechatrx', 'Comentario'=>'comentario', 'Fechacreacion'=>'fechacreacion', 'Idcolaboradorref'=>'idcolaboradorref', 'Nombrecolaboradorref'=>'nombrecolaboradorref', 'Usuariocreacion'=>'usuariocreacion'  
  );

  public function select()
  {
    try
    {
      $tamPag = !property_exists($this, 'tamPag')?9999:$this->tamPag;
      $pagina = !property_exists($this, 'page')||$this->page==""?1:$this->page;
      $numeroRegistros = $this->selectNumRows();
      $limitInf = ($pagina-1)*$tamPag;

      $where = $this->buildConsult();
      $orden = $this->buildOrderByField();

      $con = Conexion::getConexion();
      $sql = "SELECT idcreditocronocomentario, idcreditocrono, fechatrx, comentario, flagconfidencial, fechacreacion, idcolaboradorref, nombrecolaboradorref, usuariocreacion FROM cr_credito_crono_comentario WHERE 1 ".$where." ".$orden."  LIMIT ".$limitInf.",".$tamPag;
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
      $num_rows = mysql_num_rows($result);
      $a_tmp = array();
      if($num_rows>0){
        while ($o_valor = mysql_fetch_object($result)) {
          $a_tmp[] = $this->insertObjectBN($o_valor);
        }
      }
      
      return count($a_tmp)>0?$a_tmp:null;
    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  public function selectNumRows()
  {
    try
    {
      $where = $this->buildConsult();

      $con = Conexion::getConexion();
      $sql = "SELECT idcreditocronocomentario, idcreditocrono, fechatrx, comentario, flagconfidencial, fechacreacion, idcolaboradorref, nombrecolaboradorref, usuariocreacion FROM cr_credito_crono_comentario WHERE 1 ".$where;
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
      $num_rows = mysql_num_rows($result);
      
      return $num_rows;
    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  public function buildConsult()
  {
    try
    {
      $where = "";

      if($this->getIdcreditocronocomentario()){ $where .= " AND idcreditocronocomentario = '".$this->getIdcreditocronocomentario()."'"; }
      if($this->getIdcreditocrono()){ $where .= " AND idcreditocrono = '".$this->getIdcreditocrono()."'"; }
      if($this->getFechatrx()){ $where .= " AND fechatrx = '".$this->getFechatrx()."'"; }
      if($this->getComentario()){ $where .= " AND comentario = '".$this->getComentario()."'"; }
      if($this->getFechacreacion()){ $where .= " AND fechacreacion = '".$this->getFechacreacion()."'"; }
      if($this->getIdcolaboradorref()){ $where .= " AND idcolaboradorref = '".$this->getIdcolaboradorref()."'"; }
      if($this->getNombrecolaboradorref()){ $where .= " AND nombrecolaboradorref = '".$this->getNombrecolaboradorref()."'"; }
      if($this->getUsuariocreacion()){ $where .= " AND usuariocreacion = '".$this->getUsuariocreacion()."'"; }
      return $where;
    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  public function buildOrderByField()
  {
    try
    {
      $order_by = "";

      if(property_exists($this,'sortCampos')){
      if($this->sortCampos != ""){
        $a_valCampos = explode(";", $this->sortCampos);
        $a_valtype   = explode(";", $this->sortType);
        $order_by = " ORDER BY ";
        $a_order = array();
        foreach ($a_valCampos as $key => $val){
          $sTmpOrder = "";
          if(array_key_exists($val, self::$fieldNames)){
            $sTmpOrder .= self::$fieldNames[$val];
            switch ($a_valtype[$key]){
              case 1: $sTmpOrder .= " ASC"; break;
              case 2: $sTmpOrder .= " DESC"; break;
            }
            $a_order[] = $sTmpOrder;
          }
        }
        $order_by .= implode(", ", $a_order);
      }
      }
      return $order_by;
    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  /* B�squeda del registro por la llave primaria */
  public function selectByPK()
  {
    try
    {
      $con = Conexion::getConexion();
      $sql = "SELECT idcreditocronocomentario, idcreditocrono, fechatrx, comentario, fechacreacion, idcolaboradorref, nombrecolaboradorref, usuariocreacion FROM cr_credito_crono_comentario WHERE 1 AND idcreditocronocomentario='".$this->getIdcreditocronocomentario()."'; ";
        $oLink = method_exists($con, 'getResource')?$con->getResource():$con;
        $result = mysql_query($sql, $oLink);
      $o_Propel = $result ? mysql_fetch_object($result) : null;
      

      return $o_Propel?$this->insertObjectBN($o_Propel):null;

    }catch ( Exception $o_Error ){
      throw new Exception($o_Error->getMessage().' en '.$o_Error->getFile().' linea '.$o_Error->getLine());
    }
  }

  /* Devuelve un objeto con m�todos de acceso */
  private function insertObjectBN($o_propel){
    $o_BaseCrCreditoCronoComentarioFN = new BaseCrCreditoCronoComentarioFN();
    $o_BaseCrCreditoCronoComentarioFN->setIdcreditocronocomentario($o_propel->idcreditocronocomentario);
    $o_BaseCrCreditoCronoComentarioFN->setIdcreditocrono($o_propel->idcreditocrono);
    $o_BaseCrCreditoCronoComentarioFN->setFechatrx($o_propel->fechatrx);
    $o_BaseCrCreditoCronoComentarioFN->setComentario($o_propel->comentario);
    $o_BaseCrCreditoCronoComentarioFN->setFlagConfidencial($o_propel->flagconfidencial);
    $o_BaseCrCreditoCronoComentarioFN->setFechacreacion($o_propel->fechacreacion);
    $o_BaseCrCreditoCronoComentarioFN->setIdcolaboradorref($o_propel->idcolaboradorref);
    $o_BaseCrCreditoCronoComentarioFN->setNombrecolaboradorref($o_propel->nombrecolaboradorref);
    $o_BaseCrCreditoCronoComentarioFN->setUsuariocreacion($o_propel->usuariocreacion);
    return $o_BaseCrCreditoCronoComentarioFN;
  }
}